filename = 'trust ship movement data.xlsx';
data = readtable(filename);

x = [18400, 22000, 22970, 22970, 27500, 27500, 27500, 22970, 22000, 18400, 22970];
y = [8000,  8000,  7000,  2200,  2200,  7000,  9500,  9500,  8264,  8264, 7000];

y71 = 10000;
y81 = 10000;
x71 = 27500;
x81 = 22970;

y72 = 9500;
y61 = 7000;
x72 = 28000;
x61 = 28000;

x_ref = data{3:293, 5};
y_ref = data{3:293, 6};

dcpa1 = data{3:293, 22}; 
tcpa1 = data{3:293, 23}; 
time1 = data{3:293, 1};
time_in_minutes1 = time1 / 60;
tarx1 = data{3:293, 2}; 
tary1 = data{3:293, 3}; 
tarx1 = tarx1-450; 
index = tarx1 < 22000;
tary1(index) = 8132;

dcpa2 = data{296:522, 22};
tcpa2 = data{296:522, 23}; 
time2 = data{296:522, 1};
time_in_minutes2 = time2 / 60;
tarx2 = data{296:522, 2}; 
tary2 = data{296:522, 3};

dcpa3 = data{525:769, 22};
tcpa3 = data{525:769, 23};
time3 = data{525:769, 1};
time_in_minutes3 = time3 / 60;
tarx3 = data{525:769, 2};
tary3 = data{525:769, 3};

dcpa4 = data{773:end-1, 22};
tcpa4 = data{773:end-1, 23};
time4 = data{773:end-1, 1};
time_in_minutes4 = time4 / 60;
tarx4 = data{773:end-1, 2};
tary4 = data{773:end-1, 3};
tarx4 = tarx4-460;


initial_x = tarx1(1);
initial_y = tary1(1);
initial_y2 = tary2(1);
initial_y3 = tary3(1);
initial_y4 = tary4(1);



tarx2 = [initial_x; tarx2];
tary2 = [initial_y2; tary2];


tarx3 = [initial_x; tarx3];
tary3 = [initial_y3; tary3];


tarx4 = [initial_x; tarx4];
tary4 = [initial_y4; tary4];


% Use tiledlayout for a 2-row 4-column layout
t = tiledlayout(2, 2, 'TileSpacing', 'compact', 'Padding', 'compact'); 

% Add overall title for the figure
% title(t, 'The own and surrounding vessels movement trajectories', 'FontSize', 20, 'FontWeight', 'bold', 'FontName', 'Arial');

% Subplot 1: Ship and Obstacle Trajectories

plot(x_ref, y_ref, '-', 'color',[0 0.4470 0.7410], 'LineWidth', 2, 'DisplayName', 'TS trajectory'); 

hold on;
plot(tarx1, tary1, '-', 'LineWidth', 2, 'DisplayName', 'OS Left&Standard'); 
plot(tarx2, tary2, '-',  'LineWidth', 2, 'DisplayName', 'OS Right&Standard'); 
plot(tarx3, tary3, '-', 'LineWidth', 2, 'DisplayName', 'OS Right&Early'); 
plot(tarx4, tary4, '-','LineWidth', 2, 'DisplayName', 'OS Right&Imminent'); 
plot([x(1), x(2)], [y(1), y(2)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], ...
    'DisplayName', 'Traffic separation scheme'); 


plot([x(2), x(3)], [y(2), y(3)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(3), x(4)], [y(3), y(4)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(4), x(5)], [y(4), y(5)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(5), x(6)], [y(5), y(6)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(6), x(7)], [y(6), y(7)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(7), x(8)], [y(7), y(8)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(8), x(9)], [y(8), y(9)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(9), x(10)], [y(9), y(10)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(3), x(6)], [y(3), y(6)], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
plot([x(7), x71], [y(7), y71], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');

plot([x(8), x81], [y(8), y81], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');

plot([x(7), x72], [y(7), y72], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');

plot([x(6), x61], [y(6), y61], '--', 'LineWidth', 1, 'Color', [1, 0, 1], 'HandleVisibility', 'off');
quiver(20000, 7900, 800, 0, 0, 'MaxHeadSize', 0.5, 'Color',[0.9290 0.6940 0.1250] , 'MaxHeadSize', 2.0, 'LineWidth', 2.5, 'DisplayName', 'OS Direction'); % 自船方向
quiver(26600, 5700, 0, 800, 0, 'MaxHeadSize', 0.5, 'Color', [0 0.4470 0.7410], 'MaxHeadSize', 2.0, 'LineWidth', 2.5, 'DisplayName', 'TS Direction'); % 动态障碍物方向


hold off;
xlabel('X (m)', 'FontSize', 18,  'FontName', 'Arial');
ylabel('Y (m)', 'FontSize', 18, 'FontName', 'Arial');
title('Vessels trajectories', 'FontSize', 18,  'FontName', 'Arial');
legend('FontSize', 15, Location='southwest');
grid on;
set(gca, 'FontSize', 18, 'FontName', 'Arial', 'GridAlpha', 0.5);

set(gcf, 'Position', [100, 100, 800, 600]);

% Save as high-quality image
set(gcf, 'PaperPositionMode', 'auto');
saveas(gcf, 'trust_experiment_dcpa.jpg');
print(gcf, 'trust_experiment_dcpa', '-dpng', '-r300'); % Save at 600 DPI




function [dcpa, tcpa] = calc_dcpa_tcpa1(ship_state, dynamic_obstacle_state)

x_ship = ship_state(1);
y_ship = ship_state(2);
psi_ship = ship_state(3);
velocity_ship = ship_state(4);

x_obs = dynamic_obstacle_state(1); y_obs = dynamic_obstacle_state(2);
heading_obs = dynamic_obstacle_state(3); 
speed_obs = dynamic_obstacle_state(4);
velocity_obs = [cos(heading_obs); sin(heading_obs)] * speed_obs;


relative_position = [x_obs - x_ship, y_obs - y_ship];
relative_velocity = velocity_obs - velocity_ship;

%     TCPA calculation
tcpa = -dot(relative_position, relative_velocity) / (norm(relative_velocity)^2 + 1e-6);

% DCPA calculation
position_cpa = relative_position + relative_velocity * tcpa; % relative position -  CPA

dcpa = norm(position_cpa); % distance to CPA

end
